package com.loafle.bridge.discoveryhost;

import com.loafle.bridge.discoveryport.type.DirectionType;
import com.loafle.bridge.discoveryport.type.PortType;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 11/16/16.
 */
@Entity
public class PortScanHistory {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn
    private DiscoveryHost host;

    public DiscoveryHost getHost() {
        return host;
    }

    public void setHost(DiscoveryHost host) {
        this.host = host;
    }

    @Column(nullable = false)
    private short portNumber;

    @Column(nullable = false)
    @Enumerated(EnumType.STRING)
    private PortType portType;

    @Column(nullable = false)
    @Enumerated(EnumType.STRING)
    private DirectionType directionType;

    @Column(nullable = true)
    private String description;

    @Column(nullable = true)
    private Date startDate;

    @Column(nullable = true)
    private Date endDate;

    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", nullable = false, insertable = false, updatable = false)
    private Date createDate;


    public PortScanHistory(){}

    public PortScanHistory(DiscoveryHost host, short portNumber,
                           PortType portType, DirectionType directionType,
                           String description) {
        this.host = host;
        this.portNumber = portNumber;
        this.portType = portType;
        this.directionType = directionType;
        this.description = description;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public short getPortNumber() {
        return portNumber;
    }

    public void setPortNumber(short portNumber) {
        this.portNumber = portNumber;
    }

    public PortType getPortType() {
        return portType;
    }

    public void setPortType(PortType portType) {
        this.portType = portType;
    }

    public DirectionType getDirectionType() {
        return directionType;
    }

    public void setDirectionType(DirectionType directionType) {
        this.directionType = directionType;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}
